<template>
  <div
    v-loading.fullscreen.lock="fullscreenLoading"
    class="userManagement_list"
  >
    <div class="userManagement_list_headerSelect">
      <div class="userManagement-list-btn">
        <el-form :model="form" ref="form" style="display: inline" inline>
          <el-form-item class="header_top_form" label="账号：" prop="account">
            <el-input
              placeholder="请输入"
              size="small"
              v-model.trim="form.account"
              clearable
            ></el-input>
          </el-form-item>
          <el-form-item class="header_top_form" label="姓名：" prop="name">
            <el-input
              placeholder="请输入"
              size="small"
              v-model.trim="form.name"
              clearable
            ></el-input>
          </el-form-item>
        </el-form>
        <div style="margin-right: 23px">
          <el-button
            size="small"
            type="primary"
            style="width: 88px"
            @click="search"
            >查询</el-button
          >
          <el-button size="small" style="width: 88px" @click="resetForm('form')"
            >重置</el-button
          >
        </div>
      </div>
      <div style="text-align: right">
        <el-button
          size="small"
          style="width: 104px; margin-right: 23px"
          icon="iconfont icon-a-zu13"
          @click="addList"
          >新增</el-button
        >
      </div>
    </div>
    <div>
      <el-table
        :data="tableData"
        ref="editTable"
        stripe
        :header-cell-style="{ background: '#F7F7F7' }"
        :height="screenHeight"
      >
        <el-table-column
          label="账号"
          prop="account"
          align="center"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="姓名"
          prop="name"
          align="center"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column label="禁用/启用" prop="status" align="center">
          <template slot-scope="scope">
            <div>
              <div>
                <el-switch
                  v-model="scope.row.status"
                  active-color="#17A8FF"
                  inactive-color="#AFAFAF"
                  @change="statusChange($event, scope.row)"
                >
                </el-switch>
              </div>
            </div> </template
        ></el-table-column>
        <el-table-column
          label="创建时间"
          prop="createTime"
          align="center"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column label="操作" width="140px" align="center">
          <template slot-scope="scope">
            <div>
              <el-button type="text" @click="edit(scope.row)">编辑</el-button>
              <el-button
                type="text"
                @click="resetPasswords(scope.row)"
                style="color: #f4453e"
                >重置密码</el-button
              >
            </div>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <el-pagination
      @size-change="handleSizeChange"
      @current-change="handleCurrentChange"
      :current-page="form.pageNum"
      :page-sizes="[100, 200, 300, 400]"
      :page-size="form.pageSize"
      background
      layout="total,prev, pager, next,jumper"
      :total="form.total"
    >
    </el-pagination>
    <editDialog ref="editDialogRefs" />
    <detailDialog ref="detailDialogRefs" />
  </div>
</template>
<script>
import editDialog from './edit'
import detailDialog from './detail'
import * as api from '@/api/api'
export default {
  name: 'userManagement',
  components: {
    editDialog,
    detailDialog
  },
  data() {
    return {
      fullscreenLoading: false,
      tableData: [],
      form: {
        pageNum: 1,
        pageSize: 10,
        account: '',
        name: '',
        start: '',
        total: 0
      },
      screenHeight: document.body.clientHeight - 320,
      tableDataheight: 0
    }
  },
  mounted() {
    this.screenHeight = document.body.clientHeight - 320
    window.onresize = () => {
      return (() => {
        this.screenHeight = document.body.clientHeight - 320
      })()
    }
    this.listDataInit()
  },
  methods: {
    /**
     * @method 重置
     * **/
    resetForm(formName) {
      this.$refs[formName].resetFields()
      this.search()
    },
    /**
     * @method 搜索
     * **/
    search() {
      if (sessionStorage.getItem('usermanage')) {
        this.form.pageNum = Number(sessionStorage.getItem('usermanage'))
        sessionStorage.removeItem('usermanage')
      } else {
        this.form.pageNum = 1
      }

      this.listDataInit()
    },
    /**
     * @method 用户数据列表
     * **/
    listDataInit() {
      this.tableData = []
      this.fullscreenLoading = true
      let code = {
        account: this.form.account,
        name: this.form.name,
        page: this.form.pageNum,
        pageSize: this.form.pageSize,
        start: this.form.start
      }
      api
        .GET('/user/list', code)
        .then(res => {
          if (res.code == 0) {
            this.tableData = res.data.list
            this.tableData.forEach(item => {
              item.status == 1 ? (item.status = true) : (item.status = false)
            })
            this.form.pageNum = res.data.currPage
            this.form.pageSize = res.data.pageSize
            this.form.total = res.data.totalCount
            this.fullscreenLoading = false
            this.$nextTick(() => {
              this.$refs.editTable.bodyWrapper.scrollTop = this.tableDataheight
              this.tableDataheight = 0
            })
          }
        })
        .catch(() => {
          this.fullscreenLoading = false
        })
    },
    /**
     * @method 条数分页
     * **/
    handleSizeChange(val) {
      this.form.pageSize = val
      this.form.pageNum = 1
      this.listDataInit()
    },
    /**
     * @method 分页
     * **/
    handleCurrentChange(val) {
      this.form.pageNum = val
      this.listDataInit()
    },
    /**
     * @method 新增
     * **/
    addList() {
      let code = {
        title: '新增用户',
        show: true
      }
      this.$refs.editDialogRefs.openClose(code)
    },
    // 编辑
    edit(val) {
      this.tableDataheight = this.$refs.editTable.bodyWrapper.scrollTop
      sessionStorage.setItem('usermanage', this.form.pageNum)
      let code = {
        title: '编辑用户',
        show: false,
        id: val.userId
      }
      this.$refs.editDialogRefs.openClose(code)
    },
    // 重置密码
    resetPasswords(val) {
      this.tableDataheight = this.$refs.editTable.bodyWrapper.scrollTop
      sessionStorage.setItem('usermanage', this.form.pageNum)
      let code = {
        id: val.userId
      }
      this.$refs.detailDialogRefs.openClose(code)
    },
    /**
     * @method 状态修改
     * **/
    statusChange(val, item) {
      this.tableDataheight = this.$refs.editTable.bodyWrapper.scrollTop
      sessionStorage.setItem('usermanage', this.form.pageNum)
      val ? (val = 1) : (val = 0)
      let code = {
        id: item.userId,
        status: val
      }
      api
        .PUT('/user/updateSwitch', code)
        .then(data => {
          if (data.code == 0) {
            this.search()
            this.$message.success(data.message)
          }
        })
        .catch(() => {
          this.search()
        })
    }
  }
}
</script>
<style lang="less">
.userManagement_list {
  .userManagement_list_headerSelect {
    .userManagement-list-btn {
      display: flex;
      justify-content: space-between;
      align-items: center;
      margin-bottom: 10px;
    }
    margin-bottom: 20px;
    .el-form-item {
      margin-bottom: 10px;
      margin-right: 60px;
      .el-input__inner {
        background: #f5f5f5;
        opacity: 1;
        border-radius: 17px;
      }
    }
    .icon-a-zu13 {
      font-size: 11px;
      margin-right: 5px;
    }
  }
}
</style>